/*
 * getwd
 */
#if 0
#include <sys/types.h>
#include <sys/stat.h>
#else
#include <linux/types.h>
#include <asm/stat.h>
#include <linux/stat.h>
#endif
#include "axelinux_opendir.h"
#include "nlc.h"
/*
#define strlen nlc_strlen
#define strcpy nlc_strcpy
#define memcpy nlc_memcpy
*/

char*
axe_getwd(buf)
	char	*buf;
{

	aldev_t		dev, curdev, rootdev;
	alino_t		ino, curino, rootino;
	int		namlen;
	char		mount_point;
	char		*p, *t;
	ADIR		*dir;
	struct aldent	*d;
#if 0
	struct stat	st;
#else
	struct __old_kernel_stat	st;
#endif
	char		tmp[MAXNAMLEN*2+1];
	char		path[MAXNAMLEN+1];
	char		b[100], *e;
	e = b + sizeof(b);
	  /**/
//puts2(__FUNCTION__);
//putsx(__FUNCTION__ " ",(long)&b[0]);
	if(buf == NULL){
		goto owari;
	}
//puts2(__FUNCTION__);
	//namlen = lstat(".", &st);
	//			writeln_sd(1,b,e,"lstat=",namlen);
	//namlen = stat(".", &st);
	//			writeln_sd(1,b,e,"stat=",namlen);
	if(lstat(".", &st) < 0){
//puts2("owari!");
		goto owari;
	}
	curdev = st.st_dev;
	curino = st.st_ino;
//putsx("curdev=",curdev);
//putsx("curino=",curino);
//dump16(&st);
	if(lstat("/", &st) < 0){
		goto owari;
	}
	rootdev = st.st_dev;
	rootino = st.st_ino;
//putsx("rootdev=",rootdev);
//putsx("rootino=",rootino);
//dump16(&st);
	p = path + sizeof(path);
	*--p = 0;
	t = tmp;
	while(!(curdev == rootdev && curino == rootino)){
		*t++ = '.';
		*t++ = '.';
		*t = 0;
//putss("path=",tmp);
		if(lstat(tmp, &st) < 0){
			goto owari;
		}
		dev = st.st_dev;
		ino = st.st_ino;
//putsx("dev=",dev);
//putsx("ino=",ino);
//dump16(&st);
		mount_point = dev != curdev;
//write(1,"1",1);
		dir = axelinux_opendir(tmp);
//write(1,"2",1);
		if(dir == NULL){
			goto owari;
		}
//write(1,"3",1);
		*t++ = '/';
		while((d = axelinux_readdir(dir)) != NULL){
			if(d->d_name[0] == '.' &&
			    (d->d_name[1] == '\0' ||
			    (d->d_name[1] == '.' && d->d_name[2] == '\0'))){
//write(1,"3d",2);
				continue;
			}
//putsx("d->ino=",d->d_ino);
			if(mount_point || (ino_t)d->d_ino == curino){
//write(1,"3f",2);
				strcpy(t,d->d_name);
//write(1,"3g",2);
				if(lstat(tmp, &st) >= 0 &&
				    st.st_dev == curdev && st.st_ino == curino){
//write(1,"3i",2);
					break;
				}
			}
		}
//write(1,"4",1);
		if(d == NULL){
			goto owari2;
		}
		namlen = strlen(d->d_name);
		if(path > p - namlen){
			goto owari2;
		}
		p -= namlen;
		memcpy(p, d->d_name, namlen);
		*--p = '/';
		axelinux_closedir(dir);
//write(1,"5",1);
		curdev = dev;
		curino = ino;
	}
	if(*p == 0){
		*--p = '/';
	}
	//namlen = path + sizeof(path) - p;
	memcpy(buf,p, path + sizeof(path) - p);
	return buf;
owari2:
	axelinux_closedir(dir);
owari:
	return NULL;
}
